# -*- coding: utf-8 -*-
"""
Created on Fri Oct 02 14:26:07 2020

@author: Raphael J. Tostlebe
"""


import pyaudio
import numpy as np
import random

p = pyaudio.PyAudio()

"""
Lautstärke und Samplerate wird festgesetzt
"""
volume = 0.5     # range [0.0, 1.0]
fs = 44100       # sampling rate, Hz, must be integer
f = 440.0        # sine frequency, Hz, may be float

# for paFloat32 sample values must be in range [-1.0, 1.0]
stream = p.open(format=pyaudio.paFloat32,
                channels=1,
                rate=fs,
                output=True)

#Listen werden erstellt
Tondauer = []
Dauernfaktor = []
GrupAnzahl = []
Gruppendauernfaktor = []
Tonhoehe = []

Tonhoehe = [np.random.randint(32, 1333)] #Anfangston generieren


#12-Tonreihe generieren
for i in range (1,13):              
    Tonhoehe.append(Tonhoehe[0] * i)

#Tondauern generieren und zuordnen:
for i in range (0,12):
    Maxgroesse = 6*Tonhoehe[i]      #Maximalgröße bei 6s
    Mindestgroesse = Tonhoehe[i]/32 #Mindestgröße sollte bei 1/32s liegen
    Dauernfaktor.append(np.random.randint(Mindestgroesse, Maxgroesse))
    Tondauer.append(1 / Tonhoehe[i] * Dauernfaktor[i])

#Melodiekomposition
random.shuffle(Tonhoehe)                 #12-Tonreihe mischen
    
#Gruppenkomposition
GrupAnzahl.append(np.random.randint(2,14))
for i in range (0, 12):
    GrupAnzahl.append(np.random.randint(2,14))
    Gruppendauernfaktor = np.random.randint(1,12)
    MeineVariable = (GrupAnzahl[0] * Tonhoehe[0] * Gruppendauernfaktor) / Tonhoehe[1]

for i in range (2,12):
    GrupAnzahl[i] = 13
    while GrupAnzahl[i] > 13:
        Gruppendauerfaktor = np.random.randint(1,12)
        GrupAnzahl[i] = (GrupAnzahl[i-1] * Tonhoehe[i-1] * Gruppendauernfaktor) / Tonhoehe[i]
 
#Ausgabe der Komposition       
for i in range (0, 12):
    for j in range (1, GrupAnzahl[i]):
        f = Tonhoehe[i]
        duration = Tondauer[i]
        samples = (np.sin(2*np.pi*np.arange(fs*duration)*f/fs)).astype(np.float32)
        stream.write(volume*samples)    

stream.stop_stream()
stream.close()
p.terminate() 